#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "active_children4xi.py">
#<abstract4xi abstract = "provides function active_children4xi" />
#<refer4xi reference = "process.py" />
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'active_children4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass    
try:                 # rare ones
    import itertools           
except:
    pass 
       
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.process import active_children
except:
    print("active_children4xi.py *** failed in from multiprocessing.process import active_children ***")
#"
#/>
 
# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from current_process4xi import list_children_current_process4xi
from print4xi import print4xi
from time4xi import time4xi
from _cleanup4xi import _cleanup4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "active_children4xi" usage = "
#   embedded inside current_process4xi.py
#
#   managers.py:
#         for p in active_children():
#">
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/> 
# -------------------------------------------------------------------------------------------------
def active_children4xi():
    '''
    active_children4xi returns list of process objects corresponding to live child processes
    '''
           
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    
    class2print = 'active_children4xi'
    method2print = 'active_children4xi'
    
    message2print = "{started" + "; active-children4xi-started: " + str(active_children4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
           
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    
    message2print = "{calling" + "; cleanup-calling-by-active-children4xi: " + str(_cleanup4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
            
    _cleanup4xi()

    
    message2print = "{performed" + "; cleanup-performed-by-active-children4xi: " + str(_cleanup4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
  
               
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
        
    message2print = "{returning" + "; list-children-current-process4xi-function-returning-by-active-children4xi: " + str(list_children_current_process4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      

   
    
    return list_children_current_process4xi() #dragonized
#</function4xi>
#</program4xi>    

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of active_children4xi.py                            
# ------------------------------------------------------------------------------------------------- 
#"
#/>

